<template>
  <div class="app-container">
    <div class="operation">
      <el-button class="success" @click="form_add">新增盘点单</el-button>
      <el-button class="success" @click="handleInventoryList">下载盘点单</el-button>
    </div>
    <div class="search">
      <el-date-picker v-model="table.getdataListParm.parammaps.inputDatetime" class="inputDatetime filter-item" type="daterange" range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期" style="width: 250px;" />
      <el-button class="el-icon-arrow-left elIconArrowLeft" @click="handleBefore" />
      <el-button class="el-icon-arrow-right elIconArrowRight" @click="handleNext" />
      <el-button class="successBorder" @click="form_search">查询</el-button>
    </div>

    <div class="table">
      <el-table
        :key="table.tableKey"
        v-loading="table.listLoading"
        element-loading-text="给我一点时间"
        :data="table.list"
        border
        fit
        highlight-current-row
        style="width: 100%;"
        :row-style="rowStyle"
        :cell-style="cellStyle"
        class="elTable table-fixed"
      >
        <el-table-column label="序号" align="center" type="index" width="50px">
          <template slot-scope="scope">
            <span>{{ scope.$index + (table.pageNum-1) * table.pageSize + 1 }}</span>
          </template>
        </el-table-column>
        <el-table-column label="盘点日期" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.inventorydate }}</span>
          </template>
        </el-table-column>
        <el-table-column label="盘点人" min-width="130px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.createuser }}</span>
          </template>
        </el-table-column>
        <el-table-column label="盘盈库存（kg）" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.moreWeight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="盘亏库存（kg）" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.lessWeight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="盈亏净值（kg）" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.differWeight }}</span>
          </template>
        </el-table-column>
        <el-table-column label="备注" min-width="110px" align="center">
          <template slot-scope="scope">
            <span>{{ scope.row.remark }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="320" class-name="small-padding fixed-width" fixed="right">
          <template slot-scope="scope">
            <el-button class="miniPrimary" :disabled="isokDisable" @click="form_see(scope.row)">查看</el-button>
            <el-button v-if="scope.$index + (table.pageNum-1) * table.pageSize + 1 == 1" class="miniDanger" @click="form_delete(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="table.total>=0" :total="table.total" :page.sync="table.getdataListParm.offset" :limit.sync="table.getdataListParm.pagecount" @pagination="get_table_data" />
    </div>

    <!-- 新增盘点单 -->
    <el-dialog :title="textMap[create.dialogStatus]" :visible.sync="create.dialogFormVisible" :close-on-click-modal="false" width="90%">
      <div class="app-add">
        <el-form ref="createTemp" :rules="create.rules" :model="create.createTemp" label-position="right" label-width="160px" style="width: 90%;margin:0 auto">
          <el-row>
            <el-col :span="8">
              <el-form-item label="盘点日期:" prop="inventorydate">
                <el-date-picker v-model="create.createTemp.inventorydate" class="filter-item" type="date" placeholder="盘点日期" :disabled="create.dialogStatus==='see'" :picker-options="create.pickerOptions1" :clearable="false" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="盘点人:" prop="createuser">
                <el-input ref="createuser" v-model="create.createTemp.createuser" class="filter-item" placeholder="盘点人" type="text" disabled />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="备注:" prop="remark">
                <el-input ref="remark" v-model="create.createTemp.remark" class="filter-item" placeholder="备注" type="text" :disabled="create.dialogStatus==='see'" />
              </el-form-item>
            </el-col>
          </el-row>
        </el-form>
        <el-table
          :key="create.tableKey"
          v-loading="create.listLoading"
          element-loading-text="给我一点时间"
          :data="create.list"
          border
          fit
          highlight-current-row
          style="width: 100%;margin-bottom: 50px;"
          :row-style="rowStyle"
          :cell-style="cellStyle"
          class="elTable table-fixed"
        >
          <el-table-column label="饲料名称" min-width="130px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.feedname }}</span>
            </template>
          </el-table-column>
          <el-table-column label="库存重量(kg)" min-width="130px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.stockweight }}</span>
            </template>
          </el-table-column>
          <el-table-column label="实际重量(kg)" min-width="110px" align="center">
            <template slot-scope="scope">
              <el-input v-if="create.dialogStatus==='create'" ref="input" v-model="scope.row.factweight" style="width:80%;padding:10px 0;" @blur="blurFactweight(scope.row)" />
              <span v-else> {{ scope.row.factweight }}</span>
            </template>
          </el-table-column>
          <el-table-column label="差值(kg)" min-width="110px" align="center">
            <template slot-scope="scope">
              <span>{{ scope.row.differ }}</span>
            </template>
          </el-table-column>
        </el-table>
        <div slot="footer" class="dialog-footer">
          <el-button class="cancelClose" @click="create.dialogFormVisible = false; ">关闭</el-button>
          <el-button v-if="create.dialogStatus==='create'" class="success" :disabled="isokDisable" @click="add_dialog_save()">确认</el-button>
        </div>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { GetDataByName, ExecDataByConfig, failproccess, PostDataByName } from '@/api/common'
import Pagination from '@/components/Pagination'
import { parseTime } from '@/utils/index.js'
import { MessageBox } from 'element-ui'
import Cookies from 'js-cookie'
export default {
  name: 'InventoryList',
  components: { Pagination },
  data() {
    return {
      table: {
        getdataListParm: {
          name: 'getBigInventoryList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            startTime: '',
            stopTime: '',
            inputDatetime: ''
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true
      },
      textMap: {
        create: '新增',
        see: '查看盘点单'
      },
      create: {
        pickerOptions1: {
          disabledDate(time) {
            return time.getTime() > Date.now()// 当天之前的时间可选
          }
        },
        dialogFormVisible: false,
        dialogStatus: '',
        createTemp: {
          pastureid: Cookies.get('pastureid'),
          remark: '',
          inventorydate: parseTime(new Date(), '{y}-{m}-{d}'),
          createuser: Cookies.get('employename')
        },
        rules: {},
        getdataListParm: {
          name: 'getFeedstorageWeightList',
          page: 1,
          offset: 1,
          pagecount: '',
          returntype: 'Map',
          parammaps: {
            pastureid: Cookies.get('pastureid'),
            emp: Cookies.get('employename')
          }
        },
        tableKey: 0,
        list: [],
        total: 0,
        listLoading: true
      },
      see: {
        getdataListParm: {
          name: 'getInventoryList',
          page: 1,
          offset: 1,
          pagecount: 10,
          returntype: 'Map',
          parammaps: {}
        }
      },
      requestParam: {},
      isokDisable: false,
      rowStyle: { maxHeight: 50 + 'px', height: 45 + 'px' },
      cellStyle: { padding: 0 + 'px' }
    }
  },

  created() {
    this.get_table_data()
  },

  methods: {
    handleBefore() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() - 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() - 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.table.getdataListParm.parammaps.startTime = parseTime(start, '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(stop, '{y}-{m}-{d}')
        this.$forceUpdate()
      }
    },
    handleNext() {
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        var start = new Date(this.table.getdataListParm.parammaps.inputDatetime[0].setDate(this.table.getdataListParm.parammaps.inputDatetime[0].getDate() + 1))
        var stop = new Date(this.table.getdataListParm.parammaps.inputDatetime[1].setDate(this.table.getdataListParm.parammaps.inputDatetime[1].getDate() + 1))
        this.table.getdataListParm.parammaps.inputDatetime.length = 0
        this.table.getdataListParm.parammaps.inputDatetime.push(start, stop)
        this.table.getdataListParm.parammaps.startTime = parseTime(start, '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(stop, '{y}-{m}-{d}')
        this.$forceUpdate()
      }
    },
    form_search() {
      console.log('点击了查询')
      if (this.table.getdataListParm.parammaps.inputDatetime !== '' && this.table.getdataListParm.parammaps.inputDatetime !== null) {
        this.table.getdataListParm.parammaps.startTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[0], '{y}-{m}-{d}')
        this.table.getdataListParm.parammaps.stopTime = parseTime(this.table.getdataListParm.parammaps.inputDatetime[1], '{y}-{m}-{d}')
      } else {
        this.table.getdataListParm.parammaps.inputDatetime = ''
        this.table.getdataListParm.parammaps.startTime = ''
        this.table.getdataListParm.parammaps.stopTime = ''
      }
      this.table.getdataListParm.offset = 1
      this.get_table_data()
    },
    get_table_data() {
      this.table.listLoading = true
      GetDataByName(this.table.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.table.list = response.data.list
          this.table.pageNum = response.data.pageNum
          this.table.pageSize = response.data.pageSize
          this.table.total = response.data.total
        } else {
          this.table.list = []
        }
        setTimeout(() => {
          this.table.listLoading = false
        }, 100)
      })
    },

    resetCreateTemp() {
      this.create.createTemp = { pastureid: Cookies.get('pastureid'), remark: '', inventorydate: parseTime(new Date(), '{y}-{m}-{d}'), createuser: Cookies.get('employename') }
    },
    form_add() {
      console.log('点击了新增盘点单')
      this.resetCreateTemp()
      this.create.dialogStatus = 'create'
      this.create.dialogFormVisible = true
      this.getCreateList()
    },
    getCreateList() {
      this.create.listLoading = true
      GetDataByName(this.create.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          for (let i = 0; i < response.data.list.length; i++) {
            this.$set(response.data.list[i], 'factweight', '')
            this.$set(response.data.list[i], 'differ', '')
          }
          this.create.list = response.data.list
          this.create.pageNum = response.data.pageNum
          this.create.pageSize = response.data.pageSize
          this.create.total = response.data.total
        } else {
          this.create.list = []
        }
        setTimeout(() => {
          this.create.listLoading = false
        }, 100)
      })
    },
    // 实际重量
    blurFactweight(row) {
      if (row.factweight !== '' && row.stockweight !== '') {
        row.differ = parseFloat(row.factweight) - parseFloat(row.stockweight)
      }
    },
    add_dialog_save() {
      this.$refs['createTemp'].validate(valid => {
        if (valid) {
          this.isokDisable = true
          setTimeout(() => {
            this.isokDisable = false
          }, 1000)
          var createList = []
          for (let i = 0; i < this.create.list.length; i++) {
            if (this.create.list[i].factweight !== '') {
              createList.push(this.create.list[i])
            }
          }
          for (let i = 0; i < createList.length; i++) {
            const keepTwoNum = /^\d+(\.\d{1,2})?$/
            // 实际重量
            if (!keepTwoNum.test(parseFloat(createList[i].factweight))) {
              this.$message({ type: 'error', message: '实际重量请输入自然数并保留两位小数', duration: 2000 })
              return false
            }
          }

          this.requestParam.common = { 'returnmap': '0' }
          this.requestParam.data = []
          this.requestParam.data[0] = { 'name': 'insertBigInventory', 'type': 'e', 'parammaps': {
            'pastureid': this.create.createTemp.pastureid,
            'inventorydate': parseTime(this.create.createTemp.inventorydate, '{y}-{m}-{d}'),
            'createuser': this.create.createTemp.createuser,
            'remark': this.create.createTemp.remark
          }}
          this.requestParam.data[1] = { 'name': 'insertSpotList', 'resultmaps': { 'list': createList }}
          this.requestParam.data[1].children = []
          this.requestParam.data[1].children[0] = { 'name': 'insertInventory', 'type': 'e', 'parammaps': {
            invid: '@insertBigInventory.LastInsertId',
            pastureid: '@insertSpotList.pastureid',
            feedname: '@insertSpotList.feedname',
            feedid: '@insertSpotList.feedid',
            stockweight: '@insertSpotList.stockweight',
            factweight: '@insertSpotList.factweight'
          }}
          ExecDataByConfig(this.requestParam).then(response => {
            if (response.msg === 'fail') {
              const inventorydate = new RegExp("key 'inventorydate'")
              if (inventorydate.test(response.data)) {
                this.$message({ type: 'error', message: '当前日期已盘点，不可重复录入', duration: 2000 })
              } else {
                failproccess(response, this.$notify)
              }
            } else {
              this.$notify({ title: '', message: '成功', type: 'success', duration: 2000 })
              this.create.dialogFormVisible = false
              this.get_table_data()
            }
          })
        }
      })
    },

    handleInventoryList() {
      console.log('点击了下载盘点单')
    },
    form_see(row) {
      console.log('点击了查看')
      this.create.dialogStatus = 'see'
      this.create.dialogFormVisible = true
      this.create.createTemp = Object.assign({}, row)
      this.see.getdataListParm.parammaps.pastureid = row.pastureid
      this.see.getdataListParm.parammaps.id = row.id
      this.getSeeList()
    },
    getSeeList() {
      this.create.listLoading = true

      GetDataByName(this.see.getdataListParm).then(response => {
        console.log('table数据', response.data.list)
        if (response.data.list !== null) {
          this.create.list = response.data.list
          this.create.pageNum = response.data.pageNum
          this.create.pageSize = response.data.pageSize
          this.create.total = response.data.total
        } else {
          this.create.list = []
        }
        setTimeout(() => {
          this.create.listLoading = false
        }, 100)
      })
    },
    form_delete(row) {
      MessageBox.confirm('是否确认删除此信息?', {
        confirmButtonText: '确认', cancelButtonText: '取消', type: 'warning'
      }).then(() => {
        this.requestParam.name = 'deleteBigInventory'
        this.requestParam.parammaps = {}
        this.requestParam.parammaps.pastureid = row.pastureid
        this.requestParam.parammaps.id = row.id
        PostDataByName(this.requestParam).then(response => {
          if (response.msg === 'fail') {
            this.$notify({ title: '删除失败', message: response.data, type: 'warning', duration: 2000 })
          } else {
            this.$notify({ title: '成功', message: '删除成功', type: 'success', duration: 2000 })
            this.get_table_data()
          }
        })
      }).catch(() => {
        this.$message({ type: 'info', message: '已取消删除' })
      })
    }

  }
}
</script>
<style lang="scss" scoped>
  .search{margin-top:10px;}
  .table{margin-top:10px;}
</style>
<style>
  .inputDatetime .el-range-separator{ padding: 0; margin: 0 10px; }
</style>
